local media = LibStub("LibSharedMedia-3.0")

function PWBShieldbar:BuildGui()
		-- Shieldbar frame setup
	PWBShieldFrame = CreateFrame("Frame", nil, UIParent)
	PWBShieldFrame:SetFrameStrata("BACKGROUND")
	PWBShieldFrame:SetBackdrop({bgFile = media:Fetch("background", "Blizzard Tooltip"), tile = false})
	PWBShieldFrame:SetPoint("BOTTOMLEFT", self.db.x, self.db.y)

	-- Shieldbar frame movement
	PWBShieldFrame:RegisterForDrag('LeftButton')
	PWBShieldFrame:SetClampedToScreen(true)
	PWBShieldFrame:SetScript("OnDragStart", function(self) PWBShieldbar:Dragstart(self) end )
	PWBShieldFrame:SetScript('OnDragStop', function(self) PWBShieldbar:Dragstop(self) end )

	-- Shieldbar setup
	ShieldBar = CreateFrame("StatusBar", nil, PWBShieldFrame)
	ShieldBar:SetOrientation(self.db.orientation)
	ShieldBar:SetMinMaxValues(0, 100)
	ShieldBar:SetValue(0)
	ShieldBar:SetAllPoints(PWBShieldFrame)

	-- Shieldbar text setup
	ShieldBarText = ShieldBar:CreateFontString(nil, 'OVERLAY')
	ShieldBarText:SetPoint("CENTER", PWBShieldFrame, 0, 0);
	ShieldBarText:SetFont(media:Fetch("font", self.db.font), self.db.fontsize, "OUTLINE")
	ShieldBarText:SetText(0)

	PWBShieldbar:UpdateStyling()
	PWBShieldbar:UpdateVisiblity()
end

function PWBShieldbar:UpdateStyling()
	local style = nil

	if self.db.useDefaults then
		style = Protwarbar.db.profile.default.appearence
	else
		style = self.db
	end

	local scale = Protwarbar.db.profile.default.appearence.scale

	PWBShieldFrame:SetWidth(self.db.width * scale)
	PWBShieldFrame:SetHeight(self.db.height * scale)
	PWBShieldFrame:SetMovable(not Protwarbar.db.profile.locked)
	PWBShieldFrame:EnableMouse(not Protwarbar.db.profile.locked)
	PWBShieldFrame:SetPoint("BOTTOMLEFT", self.db.x, self.db.y)

	ShieldBar:SetStatusBarTexture(media:Fetch("statusbar", style.barTexture))
	ShieldBar:SetOrientation(style.orientation)
	ShieldBar:SetReverseFill(style.reverse)
	ShieldBarText:SetFont(media:Fetch("font", style.font), style.fontsize, "OUTLINE")

	ShieldBar:SetStatusBarColor(self.db.color[1], self.db.color[2], self.db.color[3], self.db.color[4])

	if Protwarbar.db.profile.locked then
		PWBShieldFrame:SetBackdropColor(style.barBackground[1], style.barBackground[2],style.barBackground[3], style.barBackground[4])
	else
		PWBShieldFrame:SetBackdropColor(Protwarbar.db.profile.default.appearence.unlockbg[1],
			Protwarbar.db.profile.default.appearence.unlockbg[2],
			Protwarbar.db.profile.default.appearence.unlockbg[3],
			Protwarbar.db.profile.default.appearence.unlockbg[4])
	end
end

function PWBShieldbar:UpdateVisiblity()
	if self.db.enabled == true and Protwarbar:IsVisible() then
		PWBShieldFrame:Show()
	else
		PWBShieldFrame:Hide()
	end
end

function PWBShieldbar:Dragstart(frame)
	if not Protwarbar.db.profile.locked then
		frame:StartMoving()
	end
end

function PWBShieldbar:Dragstop(frame)
	frame:StopMovingOrSizing()

	self.db.x = PWBShieldFrame:GetLeft()
	self.db.y = PWBShieldFrame:GetBottom()
end